Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## com.trolltech.qt.gui
Class QFontMetricsF

    java.lang.Object
      com.trolltech.qt.QSignalEmitter
          com.trolltech.qt.QtJambiObject
              com.trolltech.qt.gui.QFontMetricsF

All Implemented Interfaces:
  QtJambiInterface, java.lang.Cloneable

    public class QFontMetricsF

extends QtJambiObject
implements java.lang.Cloneable

The `QFontMetricsF` class provides font metrics information. `QFontMetricsF` functions calculate the size of characters and strings for a given font. You can construct a `QFontMetricsF` object with an existing `QFont` to obtain metrics for that font. If the font is changed later, the font metrics object is not updated.

Once created, the object provides functions to access the individual metrics of the font, its characters, and for strings rendered in the font.

There are several functions that operate on the font: `ascent()`, `descent()`, `height()`, `leading()` and `lineSpacing()` return the basic size properties of the font. The `underlinePos()`, `overlinePos()`, `strikeOutPos()` and `lineWidth()` functions, return the properties of the line that underlines, overlines or strikes out the characters. These functions are all fast.

There are also some functions that operate on the set of glyphs in the font: `minLeftBearing()`, `minRightBearing()` and `maxWidth()`. These are by necessity slow, and we recommend avoiding them if possible.

For each character, you can get its `width()`, `leftBearing()` and `rightBearing()` and find out whether it is in the font using `inFont()`. You can also treat the character as a string, and use the string functions on it.

The string functions include `width()`, to return the width of a string in pixels (or points, for a printer), `boundingRect()`, to return a rectangle large enough to contain the rendered string, and `size()`, to return the size of that rectangle.

Example:

        QFont font = new QFont("times", 24);
        QFontMetricsF fm = new QFontMetricsF(font);
        double pixelsWide = fm.width("What's the width of this text?");
        double pixelsHigh = fm.height();

See also:
  `QFont`, `QFontInfo`, and `QFontDatabase`.

Nested Class Summary

Nested classes/interfaces inherited from class com.trolltech.qt.QSignalEmitter
`QSignalEmitter.Signal0, QSignalEmitter.Signal1, QSignalEmitter.Signal2, QSignalEmitter.Signal3, QSignalEmitter.Signal4, QSignalEmitter.Signal5, QSignalEmitter.Signal6, QSignalEmitter.Signal7, QSignalEmitter.Signal8, QSignalEmitter.Signal9`

Constructor Summary
`QFontMetricsF(QFont arg__1)` Constructs a font metrics object for `font`.
`QFontMetricsF(QFontMetrics arg__1)` Constructs a font metrics object with floating point precision from the given `fontMetrics` object.
`QFontMetricsF(QFontMetricsF arg__1)` Constructs a copy of `fm`.
`QFontMetricsF(QFont arg__1, QPaintDeviceInterface pd)` Constructs a font metrics object for `font` and `paintdevice`.

Method Summary
`double` | `ascent()` Returns the ascent of the font.
`double` | `averageCharWidth()` Returns the average width of glyphs in the font.
`QRectF` | `boundingRect(char arg__1)` Returns the bounding rectangle of the character `ch` relative to the left-most point on the base line.
`QRectF` | `boundingRect(QRectF rect, int flags, java.lang.String text)` This is an overloaded function provided for convenience.
`QRectF` | `boundingRect(QRectF rect, int flags, java.lang.String text, int tabStops)` Returns the bounding rectangle of the characters in the given `text`.
`QRectF` | `boundingRect(QRectF rect, int flags, java.lang.String text, int tabStops, int[] tabArray)` Returns the bounding rectangle of the characters in the given `text`.
`QRectF` | `boundingRect(java.lang.String string)` Returns the bounding rectangle of the characters in the string specified by `text`.
`QFontMetricsF` | `clone()` This method is reimplemented for internal reasons
`double` | `descent()` Returns the descent of the font.
`java.lang.String` | `elidedText(java.lang.String text, Qt.TextElideMode mode, double width)` If the string `text` is wider than `width`, returns an elided version of the string (i.e., a string with "..." in it).
`java.lang.String` | `elidedText(java.lang.String text, Qt.TextElideMode mode, double width, int flags)` If the string `text` is wider than `width`, returns an elided version of the string (i.e., a string with "..." in it).
`static QFontMetricsF` | `fromNativePointer(QNativePointer nativePointer)` This method returns the QFontMetricsF instance pointed to by `nativePointer`.
`double` | `height()` Returns the height of the font.
`boolean` | `inFont(char arg__1)` Returns true if character `ch` is a valid character in the font; otherwise returns false.
`double` | `leading()` Returns the leading of the font.
`double` | `leftBearing(char arg__1)` Returns the left bearing of character `ch` in the font.
`double` | `lineSpacing()` Returns the distance from one base line to the next.
`double` | `lineWidth()` Returns the width of the underline and strikeout lines, adjusted for the point size of the font.
`double` | `maxWidth()` Returns the width of the widest character in the font.
`double` | `minLeftBearing()` Returns the minimum left bearing of the font.
`double` | `minRightBearing()` Returns the minimum right bearing of the font.
`static QNativePointer` | `nativePointerArray(QFontMetricsF[] array)` This function returns a QNativePointer that is pointing to the specified QFontMetricsF array.
`double` | `overlinePos()` Returns the distance from the base line to where an overline should be drawn.
`double` | `rightBearing(char arg__1)` Returns the right bearing of character `ch` in the font.
`QSizeF` | `size(int flags, java.lang.String text)` This is an overloaded function provided for convenience.
`QSizeF` | `size(int flags, java.lang.String text, int tabStops)` This is an overloaded function provided for convenience.
`QSizeF` | `size(int flags, java.lang.String text, int tabStops, int[] tabArray)` Returns the size in pixels of the characters in the given `text`.
`double` | `strikeOutPos()` Returns the distance from the base line to where the strikeout line should be drawn.
`QRectF` | `tightBoundingRect(java.lang.String text)` Returns a tight bounding rectangle around the characters in the string specified by `text`.
`double` | `underlinePos()` Returns the distance from the base line to where an underscore should be drawn.
`double` | `width(char arg__1)` See the description for details.
`double` | `width(java.lang.String string)` Returns the width in pixels of the characters in the given `text`.
`double` | `xHeight()` Returns the 'x' height of the font.

Methods inherited from class com.trolltech.qt.QtJambiObject
`dispose, disposed, equals, finalize, reassignNativeResources, tr, tr, tr`

Methods inherited from class com.trolltech.qt.QSignalEmitter
`blockSignals, disconnect, disconnect, signalsBlocked, signalSender, thread`

Methods inherited from class java.lang.Object
`getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Methods inherited from interface com.trolltech.qt.QtJambiInterface
`disableGarbageCollection, nativeId, nativePointer, reenableGarbageCollection, setJavaOwnership`

Constructor Detail

### QFontMetricsF

    public QFontMetricsF(QFont arg__1)

  Constructs a font metrics object for `font`.

  The font metrics will be compatible with the paintdevice used to create `font`.

  The font metrics object holds the information for the font that is passed in the constructor at the time it is created, and is not updated if the font's attributes are changed later.

  Use `QFontMetricsF`(const `QFont` &, `QPaintDevice` *) to get the font metrics that are compatible with a certain paint device.

### QFontMetricsF

    public QFontMetricsF(QFont arg__1,
                         QPaintDeviceInterface pd)

  Constructs a font metrics object for `font` and `paintdevice`.

  The font metrics will be compatible with the paintdevice passed. If the `paintdevice` is 0, the metrics will be screen-compatible, ie. the metrics you get if you use the font for drawing text on a `widgets` or `pixmaps`, not on a `QPicture` or `QPrinter`.

  The font metrics object holds the information for the font that is passed in the constructor at the time it is created, and is not updated if the font's attributes are changed later.

### QFontMetricsF

    public QFontMetricsF(QFontMetrics arg__1)

  Constructs a font metrics object with floating point precision from the given `fontMetrics` object.

### QFontMetricsF

    public QFontMetricsF(QFontMetricsF arg__1)

  Constructs a copy of `fm`.

Method Detail

### ascent

    public final double ascent()

  Returns the ascent of the font.

  The ascent of a font is the distance from the baseline to the highest position characters extend to. In practice, some font designers break this rule, e.g. when they put more than one accent on top of a character, or to accommodate an unusual character in an exotic language, so it is possible (though rare) that this value will be too small.

See also:
  `descent()`.

### averageCharWidth

    public final double averageCharWidth()

  Returns the average width of glyphs in the font.

### boundingRect

    public final QRectF boundingRect(char arg__1)

  Returns the bounding rectangle of the character `ch` relative to the left-most point on the base line.

  Note that the bounding rectangle may extend to the left of (0, 0), e.g. for italicized fonts, and that the text output may cover all pixels in the bounding rectangle.

  Note that the rectangle usually extends both above and below the base line.

See also:
  `width()`.

### boundingRect

    public final QRectF boundingRect(java.lang.String string)

  Returns the bounding rectangle of the characters in the string specified by `text`. The bounding rectangle always covers at least the set of pixels the text would cover if drawn at (0, 0).

  Note that the bounding rectangle may extend to the left of (0, 0), e.g. for italicized fonts, and that the width of the returned rectangle might be different than what the `width()` method returns.

  If you want to know the advance width of the string (to layout a set of strings next to each other), use `width()` instead.

  Newline characters are processed as normal characters, not as linebreaks.

  The height of the bounding rectangle is at least as large as the value returned `height()`.

See also:
  `width()`, `height()`, and `QPainter::boundingRect()`.

### descent

    public final double descent()

  Returns the descent of the font.

  The descent is the distance from the base line to the lowest point characters extend to. (Note that this is different from X, which adds 1 pixel.) In practice, some font designers break this rule, e.g. to accommodate an unusual character in an exotic language, so it is possible (though rare) that this value will be too small.

See also:
  `ascent()`.

### elidedText

    public final java.lang.String elidedText(java.lang.String text,
                                             Qt.TextElideMode mode,
                                             double width)

  If the string `text` is wider than `width`, returns an elided version of the string (i.e., a string with "..." in it). Otherwise, returns the original string.

  The `mode` parameter specifies whether the text is elided on the left (e.g., "...tech"), in the middle (e.g., "Tr...ch"), or on the right (e.g., "Trol...").

  The `width` is specified in pixels, not characters.

  The `flags` argument is optional and currently only supports `Qt::TextShowMnemonic` as value.

### elidedText

    public final java.lang.String elidedText(java.lang.String text,
                                             Qt.TextElideMode mode,
                                             double width,
                                             int flags)

  If the string `text` is wider than `width`, returns an elided version of the string (i.e., a string with "..." in it). Otherwise, returns the original string.

  The `mode` parameter specifies whether the text is elided on the left (e.g., "...tech"), in the middle (e.g., "Tr...ch"), or on the right (e.g., "Trol...").

  The `width` is specified in pixels, not characters.

  The `flags` argument is optional and currently only supports `Qt::TextShowMnemonic` as value.

### height

    public final double height()

  Returns the height of the font.

  This is always equal to `ascent()`+`descent()`+1 (the 1 is for the base line).

See also:
  `leading()`, and `lineSpacing()`.

### inFont

    public final boolean inFont(char arg__1)

  Returns true if character `ch` is a valid character in the font; otherwise returns false.

### leading

    public final double leading()

  Returns the leading of the font.

  This is the natural inter-line spacing.

See also:
  `height()`, and `lineSpacing()`.

### leftBearing

    public final double leftBearing(char arg__1)

  Returns the left bearing of character `ch` in the font.

  The left bearing is the right-ward distance of the left-most pixel of the character from the logical origin of the character. This value is negative if the pixels of the character extend to the left of the logical origin.

  See width(QChar) for a graphical description of this metric.

See also:
  `rightBearing()`, `minLeftBearing()`, and `width()`.

### lineSpacing

    public final double lineSpacing()

  Returns the distance from one base line to the next.

  This value is always equal to `leading()`+`height()`.

See also:
  `height()`, and `leading()`.

### lineWidth

    public final double lineWidth()

  Returns the width of the underline and strikeout lines, adjusted for the point size of the font.

See also:
  `underlinePos()`, `overlinePos()`, and `strikeOutPos()`.

### maxWidth

    public final double maxWidth()

  Returns the width of the widest character in the font.

### minLeftBearing

    public final double minLeftBearing()

  Returns the minimum left bearing of the font.

  This is the smallest `leftBearing`(char) of all characters in the font.

  Note that this function can be very slow if the font is large.

See also:
  `minRightBearing()`, and `leftBearing()`.

### minRightBearing

    public final double minRightBearing()

  Returns the minimum right bearing of the font.

  This is the smallest `rightBearing`(char) of all characters in the font.

  Note that this function can be very slow if the font is large.

See also:
  `minLeftBearing()`, and `rightBearing()`.

### overlinePos

    public final double overlinePos()

  Returns the distance from the base line to where an overline should be drawn.

See also:
  `underlinePos()`, `strikeOutPos()`, and `lineWidth()`.

### rightBearing

    public final double rightBearing(char arg__1)

  Returns the right bearing of character `ch` in the font.

  The right bearing is the left-ward distance of the right-most pixel of the character from the logical origin of a subsequent character. This value is negative if the pixels of the character extend to the right of the `width()` of the character.

  See `width()` for a graphical description of this metric.

See also:
  `leftBearing()`, `minRightBearing()`, and `width()`.

### strikeOutPos

    public final double strikeOutPos()

  Returns the distance from the base line to where the strikeout line should be drawn.

See also:
  `underlinePos()`, `overlinePos()`, and `lineWidth()`.

### tightBoundingRect

    public final QRectF tightBoundingRect(java.lang.String text)

  Returns a tight bounding rectangle around the characters in the string specified by `text`. The bounding rectangle always covers at least the set of pixels the text would cover if drawn at (0, 0).

  Note that the bounding rectangle may extend to the left of (0, 0), e.g. for italicized fonts, and that the width of the returned rectangle might be different than what the `width()` method returns.

  If you want to know the advance width of the string (to layout a set of strings next to each other), use `width()` instead.

  Newline characters are processed as normal characters, not as linebreaks.

  Warning: Calling this method is very slow on Windows.

See also:
  `width()`, `height()`, and `boundingRect()`.

### underlinePos

    public final double underlinePos()

  Returns the distance from the base line to where an underscore should be drawn.

See also:
  `overlinePos()`, `strikeOutPos()`, and `lineWidth()`.

### width

    public final double width(char arg__1)

  See the description for details.
  Returns the logical width of character `ch` in pixels. This is a distance appropriate for drawing a subsequent character after `ch`.

  Some of the metrics are described in the image to the right. The central dark rectangles cover the logical `width()` of each character. The outer pale rectangles cover the `leftBearing()` and `rightBearing()` of each character. Notice that the bearings of "f" in this particular font are both negative, while the bearings of "o" are both positive.

  Warning: This function will produce incorrect results for Arabic characters or non-spacing marks in the middle of a string, as the glyph shaping and positioning of marks that happens when processing strings cannot be taken into account. Use charWidth() instead if you aren't looking for the width of isolated characters.

See also:
  `boundingRect()`.

### width

    public final double width(java.lang.String string)

  Returns the width in pixels of the characters in the given `text`.

  Note that this value is not equal to the width returned by `boundingRect()`.`width()` because `boundingRect()` returns a rectangle describing the pixels this string will cover whereas `width()` returns the distance to where the next string should be drawn.

See also:
  `boundingRect()`.

### xHeight

    public final double xHeight()

  Returns the 'x' height of the font. This is often but not always the same as the height of the character 'x'.

### fromNativePointer

    public static QFontMetricsF fromNativePointer(QNativePointer nativePointer)

  This method returns the QFontMetricsF instance pointed to by `nativePointer`.

### nativePointerArray

    public static QNativePointer nativePointerArray(QFontMetricsF[] array)

  This function returns a QNativePointer that is pointing to the specified QFontMetricsF array.

### boundingRect

    public final QRectF boundingRect(QRectF rect,
                                     int flags,
                                     java.lang.String text,
                                     int tabStops,
                                     int[] tabArray)

  Returns the bounding rectangle of the characters in the given `text`. This is the set of pixels the text would cover if drawn when constrained to the bounding rectangle specified by `rect`.

  The `flags` argument is the bitwise OR of the following flags:

  - `Qt::AlignLeft` aligns to the left border, except for Arabic and Hebrew where it aligns to the right.
  - `Qt::AlignRight` aligns to the right border, except for Arabic and Hebrew where it aligns to the left.
  - `Qt::AlignJustify` produces justified text.
  - `Qt::AlignHCenter` aligns horizontally centered.
  - `Qt::AlignTop` aligns to the top border.
  - `Qt::AlignBottom` aligns to the bottom border.
  - `Qt::AlignVCenter` aligns vertically centered
  - `Qt::AlignCenter` (== `Qt::AlignHCenter | Qt::AlignVCenter`)
  - `Qt::TextSingleLine` ignores newline characters in the text.
  - `Qt::TextExpandTabs` expands tabs (see below)
  - `Qt::TextShowMnemonic` interprets "&x" as x, i.e. underlined.
  - `Qt::TextWordWrap` breaks the text to fit the rectangle.
  `Qt::Horizontal` alignment defaults to `Qt::AlignLeft` and vertical alignment defaults to `Qt::AlignTop` .

  If several of the horizontal or several of the vertical alignment flags are set, the resulting alignment is undefined.

  These flags are defined in `Qt::AlignmentFlag` .

  If `Qt::TextExpandTabs` is set in `flags`, the following behavior is used to interpret tab characters in the text:

  - If `tabArray` is non-null, it specifies a 0-terminated sequence of pixel-positions for tabs in the text.
  - If `tabStops` is non-zero, it is used as the tab spacing (in pixels).
  Note that the bounding rectangle may extend to the left of (0, 0), e.g. for italicized fonts.

  Newline characters are processed as line breaks.

  Despite the different actual character heights, the heights of the bounding rectangles of "Yes" and "yes" are the same.

  The bounding rectangle returned by this function is somewhat larger than that calculated by the simpler `boundingRect()` function. This function uses the `maximum left` and `right` font bearings as is necessary for multi-line text to align correctly. Also, fontHeight() and `lineSpacing()` are used to calculate the height, rather than individual character heights.

See also:
  `width()`, `QPainter::boundingRect()`, and Qt::Alignment.

### boundingRect

    public final QRectF boundingRect(QRectF rect,
                                     int flags,
                                     java.lang.String text,
                                     int tabStops)

  Returns the bounding rectangle of the characters in the given `text`. This is the set of pixels the text would cover if drawn when constrained to the bounding rectangle specified by `rect`.

  The `flags` argument is the bitwise OR of the following flags:

  - Qt::AlignLeft aligns to the left border, except for Arabic and Hebrew where it aligns to the right.
  - Qt::AlignRight aligns to the right border, except for Arabic and Hebrew where it aligns to the left.
  - Qt::AlignJustify produces justified text.
  - Qt::AlignHCenter aligns horizontally centered.
  - Qt::AlignTop aligns to the top border.
  - Qt::AlignBottom aligns to the bottom border.
  - Qt::AlignVCenter aligns vertically centered
  - Qt::AlignCenter (== Qt::AlignHCenter | Qt::AlignVCenter)
  - Qt::TextSingleLine ignores newline characters in the text.
  - Qt::TextExpandTabs expands tabs (see below)
  - Qt::TextShowMnemonic interprets "&x" as x, i.e. underlined.
  - Qt::TextWordBreak breaks the text to fit the rectangle.

    Qt::Horizontal alignment defaults to Qt::AlignLeft and vertical alignment defaults to Qt::AlignTop.

    If several of the horizontal or several of the vertical alignment flags are set, the resulting alignment is undefined.

    These flags are defined in Qt::AlignmentFlag.

    If Qt::TextExpandTabs is set in `flags`, the following behavior is used to interpret tab characters in the text:

  - If `tabArray` is non-null, it specifies a 0-terminated sequence of pixel-positions for tabs in the text.
  - If `tabStops` is non-zero, it is used as the tab spacing (in pixels).

    Note that the bounding rectangle may extend to the left of (0, 0), e.g. for italicized fonts.

    Newline characters are processed as line breaks.

    Despite the different actual character heights, the heights of the bounding rectangles of "Yes" and "yes" are the same.

    The bounding rectangle returned by this function is somewhat larger than that calculated by the simpler boundingRect() function. This function uses the minLeftBearing() maximum left and minRightBearing() right font bearings as is necessary for multi-line text to align correctly. Also, fontHeight() and lineSpacing() are used to calculate the height, rather than individual character heights.

### boundingRect

    public final QRectF boundingRect(QRectF rect,
                                     int flags,
                                     java.lang.String text)

  This is an overloaded function provided for convenience.

### size

    public final QSizeF size(int flags,
                             java.lang.String text,
                             int tabStops,
                             int[] tabArray)

  Returns the size in pixels of the characters in the given `text`.

  The `flags` argument is the bitwise OR of the following flags:

  - `Qt::TextSingleLine` ignores newline characters.
  - `Qt::TextExpandTabs` expands tabs (see below)
  - `Qt::TextShowMnemonic` interprets "&x" as x, i.e. underlined.
  - `Qt::TextWordBreak` breaks the text to fit the rectangle.
  These flags are defined in Qt::TextFlags.

  If `Qt::TextExpandTabs` is set in `flags`, the following behavior is used to interpret tab characters in the text:

  - If `tabArray` is non-null, it specifies a 0-terminated sequence of pixel-positions for tabs in the text.
  - If `tabStops` is non-zero, it is used as the tab spacing (in pixels).
  Newline characters are processed as line breaks.

  Note: Despite the different actual character heights, the heights of the bounding rectangles of "Yes" and "yes" are the same.

See also:
  `boundingRect()`.

### size

    public final QSizeF size(int flags,
                             java.lang.String text,
                             int tabStops)

  This is an overloaded function provided for convenience.

### size

    public final QSizeF size(int flags,
                             java.lang.String text)

  This is an overloaded function provided for convenience.

### clone

    public QFontMetricsF clone()

  This method is reimplemented for internal reasons

  Overrides:
    `clone` in class `java.lang.Object`

Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD